fgl-5.4.2.4: Martin Erwig's Functional Graph Library

Safe Haskell | None

Data.Graph.Inductive.Monad.IOArray

Contents

- Graph Representation
- Utilities

Description

Static IOArray-based Graphs

Synopsis

- data SGr a b = SGr (GraphRep a b)
- type GraphRep a b = (Int, Array Node (Context' a b), IOArray Node Bool)
- type Context' a b = Maybe (Adj b, a, Adj b)
- type USGr = SGr () ()
- defaultGraphSize :: Int
- emptyN :: Int -> IO (SGr a b)
- removeDel :: IOArray Node Bool -> Adj b -> IO (Adj b)

# Graph Representation

data SGr a b Source

Constructors

SGr (GraphRep a b) |

Instances

GraphM IO SGr |
(Show a, Show b) => Show (IO (SGr a b)) |
(Show a, Show b) => Show (SGr a b) |

type GraphRep a b = (Int, Array Node (Context' a b), IOArray Node Bool)Source

type Context' a b = Maybe (Adj b, a, Adj b)Source

type USGr = SGr () ()Source

defaultGraphSize :: Int Source

emptyN :: Int -> IO (SGr a b)Source

# Utilities

removeDel :: IOArray Node Bool -> Adj b -> IO (Adj b)Source

filter list (of successors/predecessors) through a boolean ST array representing deleted marks